unit u_23_wm_touch;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    clear_: TButton;
    Panel1: TPanel;
    procedure clear_Click(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  private
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
  public
    procedure WMTouch(var Message: TMessage); message WM_TOUCH;
  end;

var
  Form1: TForm1;

implementation
  uses Vcl.Touch.Gestures;

  {$R *.dfm}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end;


    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end;

    procedure TForm1.CreateWnd;
      begin
        inherited;
        RegisterTouchWindow(Handle, 0);
      end;

    procedure TForm1.DestroyWnd;
      begin
        inherited;
        UnregisterTouchWindow(Handle);
      end;

    procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
        Y: Integer);
      begin
        Panel1.Caption:= Format('  X=%3d Y=%3d', [X, Y]);
      end;

    procedure TForm1.WMTouch(var Message: TMessage);

      function f_touchpoint_to_touch(const TouchPoint: TTouchInput): TPoint;
        begin
          Result := Point(TouchPoint.X div 100, TouchPoint.Y div 100);
          PhysicalToLogicalPoint(Handle, Result);
        end; // f_touchpoint_to_touch

      var l_touchinput_array: array of TTouchInput;
          l_touchinput: TTouchInput;
          l_handled: Boolean;
          l_point: TPoint;

      begin // WMTouch
        display('wm_touch');
        l_handled := False;
        SetLength(l_touchinput_array, Message.WParam);
        display('  count '+ IntToStr(Message.WParam));

        GetTouchInputInfo(Message.LParam, Message.WParam, @l_touchinput_array[0],
            SizeOf(TTouchInput));


        try
          for l_touchinput in l_touchinput_array do
          begin
            l_point := f_touchpoint_to_touch(l_touchinput);
            display(Format ('  scr X=%3d Y=%3d  win X-L=%3d Y-T=%3d',
                [l_point.X, l_point.Y, Left+ l_point.X, l_point.X- Left, l_point.Y- Top]));
          end;

          l_handled := True;
        finally
          if l_handled then
            CloseTouchInputHandle(Message.LParam)
          else
            inherited;
        end;
      end; // WMTouch

end.
